## ros-noetic-rm-chassis-controllers 0.1.7

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)
project(rm_chassis_controllers)

## Use C++14
set(CMAKE_CXX_STANDARD 14)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

## By adding -Wall and -Werror, the compiler does not ignore warnings anymore,
## enforcing cleaner code.
add_definitions(-Wall -Werror -Wno-enum-compare)

## Find catkin macros and libraries
find_package(catkin REQUIRED
        COMPONENTS
        roscpp

        rm_common

        effort_controllers
        tf2_geometry_msgs
        )

find_package(Eigen3 REQUIRED)

###################################
## catkin specific configuration ##
###################################
## The catkin_package macro generates cmake config files for your package
## Declare things to be passed to dependent projects
## INCLUDE_DIRS: uncomment this if your package contains header files
## LIBRARIES: libraries you create in this project that dependent projects also need
## CATKIN_DEPENDS: catkin_packages dependent projects also need
## DEPENDS: system dependencies of this project that dependent projects also need
catkin_package(
        INCLUDE_DIRS
        include
        ${EIGEN3_INCLUDE_DIR}
        LIBRARIES
        CATKIN_DEPENDS
        roscpp

        rm_common

        effort_controllers
        tf2_geometry_msgs
        LIBRARIES ${PROJECT_NAME}
)

###########
## Build ##
###########

## Specify additional locations of header files
include_directories(
        include
        ${catkin_INCLUDE_DIRS}
        ${EIGEN3_INCLUDE_DIR}
)

## Declare cpp executables
add_library(${PROJECT_NAME}
        src/chassis_base.cpp
        src/omni.cpp
        src/sentry.cpp
        src/swerve.cpp
        src/reaction_wheel.cpp
        )

## Specify libraries to link executable targets against
target_link_libraries(${PROJECT_NAME}
        ${catkin_LIBRARIES}
        )

#############
## Install ##
#############

# Mark executables and/or libraries for installation
install(
        TARGETS ${PROJECT_NAME}
        ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
        LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
        RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)

# Mark cpp header files for installation
install(
        DIRECTORY include/${PROJECT_NAME}/
        DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
        FILES_MATCHING PATTERN "*.h"
)

# Mark other files for installation
install(
        DIRECTORY test
        DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}
)
install(
        FILES rm_chassis_controllers_plugins.xml
        DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}
)

#############
## Testing ##
#############

#if (${CATKIN_ENABLE_TESTING})
#  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pthread")
#  ## Add gtest based cpp test target and link libraries
#  catkin_add_gtest(${PROJECT_NAME}-test
#      test/test_ros_package_template.cpp
#      test/AlgorithmTest.cpp)
#  target_link_libraries(${PROJECT_NAME}-test ${PROJECT_NAME}_core)
#endif ()

=== debian/changelog ===
ros-noetic-rm-chassis-controllers (0.1.7-1buster) buster; urgency=high

  * Merge pull request #83 <https://github.com/ye-luo-xi-tui/rm_controllers/issues/83> from rm-controls/dev
    Merge the new OmniController to master
  * Merge pull request #82 <https://github.com/ye-luo-xi-tui/rm_controllers/issues/82> from NaHCO3bc/dev
    Fix some bugs in the new OmniController.
  * Compute the params and fix some bugs.
  * Rename the function forwardKinematics to odometry.
  * Merge pull request #80 <https://github.com/ye-luo-xi-tui/rm_controllers/issues/80> from qiayuanliao/master
    New and elegant OmniController
  * Fix bug in the new OmniController
  * Add a new and elegant OmniController
  * Merge remote-tracking branch 'origin/master'
  * Contributors: NaHCO3bc, QiayuanLiao, qiayuan

 -- Qiayuan Liao <liaoqiayuan@gmail.com>  Sat, 10 Sep 2022 00:00:00 -0000

ros-noetic-rm-chassis-controllers (0.1.6-1buster) buster; urgency=high

  * Merge remote-tracking branch 'origin/master'
  * Contributors: qiayuan

 -- Qiayuan Liao <liaoqiayuan@gmail.com>  Thu, 16 Jun 2022 00:00:00 -0000

ros-noetic-rm-chassis-controllers (0.1.5-1buster) buster; urgency=high

  * Update frames in update function.
  * Add command_source_frame to follow mode.
  * Merge remote-tracking branch 'origin/master'
  * 0.1.4
  * Add damping behavior to ReactionWheelController
  * Add recover behavior to ReactionWheelController
  * Add a low-pass filter to eliminate the constant pitch angle offset to ReactionWheelController
  * Add a naive method for determining orientation of balance chassis
  * Use new reaction wheel state space model
  * Add setZero to Q and R
  * Merge remote-tracking branch 'origin/master'
  * Remove "convert model from continuous to discrete time" from ReactionWheel, the rm_common::Lqr accept continuous model.
  * Merge pull request #57 <https://github.com/ye-luo-xi-tui/rm_controllers/issues/57> from NaHCO3bc/master
    Update ReactionWheelController
  * Change the number of joint name reads,change the QR matrix to an array and update the rm_chassis_controllers_plugins.xml.
  * Merge branch 'chassis/reaction_wheel'
  * Merge pull request #56 <https://github.com/ye-luo-xi-tui/rm_controllers/issues/56> from NaHCO3bc/chassis/reaction_wheel
    Update ReactionWheelController
  * Update reaction_wheel.cpp and add template_reaction_wheel.yaml
  * Add some comments of ReactionWheelController
  * Remove BalanceController
  * Add ReactionWheelController
  * Merge pull request #51 <https://github.com/ye-luo-xi-tui/rm_controllers/issues/51> from Edwinlinks/sentry_catapult
    Complete sentry catapult and delete the redundant code
  * Merge branch 'master' into gimbal_track
  * Complete sentry catapult and delete the redundant code
  * Merge pull request #45 <https://github.com/ye-luo-xi-tui/rm_controllers/issues/45> from mlione/master
    Delete some config files in rm_controllers.
  * Merge pull request #50 <https://github.com/ye-luo-xi-tui/rm_controllers/issues/50> from ye-luo-xi-tui/ori
    Make rm_orientation_controller publish tf use imu data on the topic
  * Delete some config files in rm_controller.
  * Add a param publish_odom_tf, it decided whether tf would be published.
  * Merge pull request #46 <https://github.com/ye-luo-xi-tui/rm_controllers/issues/46> from ye-luo-xi-tui/master
    Deprecated imu_filter_controller
  * Merge branch 'master' into gimbal_track
  * Contributors: Edwinlinks, QiayuanLiao, YuuinIH, mlione, nahco3bc, qiayuan, yezi

 -- Qiayuan Liao <liaoqiayuan@gmail.com>  Fri, 10 Jun 2022 00:00:00 -0000

ros-noetic-rm-chassis-controllers (0.1.3-1buster) buster; urgency=high

  * Merge branch 'master' into forward_feed
  * Merge pull request #40 <https://github.com/ye-luo-xi-tui/rm_controllers/issues/40> from ye-luo-xi-tui/maintain
    Delete configuration of robot_state_controller in each of controllers' config file
  * Merge branch 'master' into maintain
    # Conflicts:
    #     rm_chassis_controllers/config/standard3.yaml
  * Merge pull request #41 <https://github.com/ye-luo-xi-tui/rm_controllers/issues/41> from ye-luo-xi-tui/standard3
    Update standard3 config
  * Merge branch 'master' into 'standard3'.
  * Merge branch 'master' into maintain
    # Conflicts:
    #     rm_chassis_controllers/config/standard3.yaml
    #     rm_chassis_controllers/config/standard4.yaml
  * Delete configuration of robot_state_controller in each of controllers' config file
  * Merge branch 'master' into standard3
  * Add missing parameters and format rm_chassis_controllers
  * Update standard3 config
  * Merge remote-tracking branch 'origin/master'
  * Update standard3 chassis_controller config.
  * Contributors: QiayuanLiao, qiayuan, ye-luo-xi-tui, yezi

 -- Qiayuan Liao <liaoqiayuan@gmail.com>  Mon, 28 Mar 2022 00:00:00 -0000

ros-noetic-rm-chassis-controllers (0.1.2-1buster) buster; urgency=high

  * Merge pull request #31 <https://github.com/rm-controls/rm_controllers/issues/31> from ye-luo-xi-tui/modify_params
    Modify chassis configuration
  * Update standard3.yaml.
  * Update sentry chassis config.
  * Update standard5.yaml
  * Merge pull request #27 <https://github.com/rm-controls/rm_controllers/issues/27> from ye-luo-xi-tui/omni_wheel_controller
    Add omni wheel controller
  * Fix bug in kinematics.
  * Change param name.
  * Merge branch 'master' into omni_wheel_controller
  * Merge remote-tracking branch 'origin/master'
  * Merge branch 'rm-controls:master' into master
  * Merge pull request #24 <https://github.com/rm-controls/rm_controllers/issues/24> from ye-luo-xi-tui/fix_power_limit
    Fix a bug in power limit.
  * Add OmniController.
  * Fix a bug in power limit.
    (cherry picked from commit 81d1e880ea67aed189cb762819f63d4a5fba6b9b)
  * Merge remote-tracking branch 'origin/master'
  * Merge branch 'rm-controls:master' into master
  * Merge branch 'rm-controls:master' into master


=== debian/control ===
Source: ros-noetic-rm-chassis-controllers
Section: misc
Priority: optional
Maintainer: Qiayuan Liao <liaoqiayuan@gmail.com>
Build-Depends: debhelper (>= 9.0.0), ros-noetic-catkin, ros-noetic-effort-controllers, ros-noetic-rm-common, ros-noetic-roscpp, ros-noetic-tf2-geometry-msgs
Homepage: 
Standards-Version: 3.9.2

Package: ros-noetic-rm-chassis-controllers
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-noetic-effort-controllers, ros-noetic-rm-common, ros-noetic-robot-localization, ros-noetic-roscpp, ros-noetic-tf2-geometry-msgs
Description: RoboMaster standard robot Chassis controller

## ros-noetic-rm-chassis-controllers 0.1.10

=== CMakeLists.txt ===
--- 
+++ 
@@ -16,8 +16,10 @@
 
         rm_common
 
+        controller_interface
         effort_controllers
         tf2_geometry_msgs
+        angles
         )
 
 find_package(Eigen3 REQUIRED)
@@ -63,7 +65,7 @@
         src/omni.cpp
         src/sentry.cpp
         src/swerve.cpp
-        src/reaction_wheel.cpp
+        src/balance.cpp
         )
 
 ## Specify libraries to link executable targets against

=== debian/changelog ===
ros-noetic-rm-chassis-controllers (0.1.10-1focal) focal; urgency=high

  * Merge pull request #112 <https://github.com/ye-luo-xi-tui/rm_controllers/issues/112> from ljq-lv/Delete
    Delete the chassis mode "GYRO"
  * Merge pull request #115 <https://github.com/ye-luo-xi-tui/rm_controllers/issues/115> from Edwinlinks/fix-odom
    Add manner to fix odom2base by adding outside odometry.
  * Merge pull request #119 <https://github.com/ye-luo-xi-tui/rm_controllers/issues/119> from ye-luo-xi-tui/balance_standard
    Clear position when position_des minus position_act bigger than threshold
  * Modify topic name and add comment.
  * Delete the unused header.
  * Add manner to fix odom2base by adding outside odometry.
  * Merge branch 'rm-controls:master' into master
  * Modified the chassis's README
  * Delete the chassis mode "GYRO"
  * Merge pull request #111 <https://github.com/ye-luo-xi-tui/rm_controllers/issues/111> from d0h0s/master
    Updated README.md of rm_chassis_controllers.
  * Repaired the example of chassis_controller.
  * Added the parameters of Omni and fixed the inappropriate description.
  * Updated README.md of rm_chassis_controllers.
  * Merge pull request #108 <https://github.com/ye-luo-xi-tui/rm_controllers/issues/108> from Aung-xiao/master
    add mecanum.yaml
  * change the name of the controller
  * add mecanum.yaml
  * Merge pull request #106 <https://github.com/ye-luo-xi-tui/rm_controllers/issues/106> from ye-luo-xi-tui/master
    0.1.9
  * Clear position when position_des minus position_act bigger than threshold.
  * Contributors: Aung-xiao, Edwinlinks, QiayuanLiao, d0h0s, ljq-lv, ye-luo-xi-tui, yezi

 -- Qiayuan Liao <liaoqiayuan@gmail.com>  Sat, 25 Mar 2023 00:00:00 -0000

ros-noetic-rm-chassis-controllers (0.1.9-1focal) focal; urgency=high

  * Merge pull request #105 <https://github.com/ye-luo-xi-tui/rm_controllers/issues/105> from ljq-lv/gimbal_toward
    Add follow gimbal's chassis control
  * Add follow gimbal's chassis control
  * Add follow gimbal's chassis control
  * Merge pull request #100 <https://github.com/ye-luo-xi-tui/rm_controllers/issues/100> from ye-luo-xi-tui/balance_standard
    Add balance chassis controller
  * Update note.
  * Update test.
  * Update controller description.
  * Merge branch 'master' into balance_standard
  * Modify the expected location update policy.
  * Take some joints' name as params.
  * Fix warning.
  * Add power limit.
  * Compute state matrix and control matrix with given params.
  * Add balance_chassis's odometry.
  * Transform IMU's data to base_link.
  * Try to use PID controller to fix the problem that one block's position is differ from another.
  * Revised dynamics model and remove gazebo dependency.
  * Merge pull request #97 <https://github.com/ye-luo-xi-tui/rm_controllers/issues/97> from ye-luo-xi-tui/master
    0.1.8
  * Fix mistake of orientation data.
  * Add some test codes for balance chassis.
  * Contributors: ljq-lv, ye-luo-xi-tui, yezi

 -- Qiayuan Liao <liaoqiayuan@gmail.com>  Tue, 21 Feb 2023 00:00:00 -0000

ros-noetic-rm-chassis-controllers (0.1.8-1focal) focal; urgency=high

  * Merge branch 'master' into target_velocity_correction
  * Merge pull request #89 <https://github.com/ye-luo-xi-tui/rm_controllers/issues/89> from rm-controls/dev
    Merge branch 'dev' into master
  * Merge pull request #88 <https://github.com/ye-luo-xi-tui/rm_controllers/issues/88> from NaHCO3bc/dev
    Add a push_back of joint_handles in the new OmniController.
  * Add a push_back of joint_handles in the new OmniController.
  * Merge pull request #86 <https://github.com/ye-luo-xi-tui/rm_controllers/issues/86> from NaHCO3bc/Readme
    Fix the dependence part bug.
  * Fix the dependence part bug.
  * Merge pull request #85 <https://github.com/ye-luo-xi-tui/rm_controllers/issues/85> from ye-luo-xi-tui/master
    0.1.7
  * Contributors: NaHCO3bc, ye-luo-xi-tui, yezi

 -- Qiayuan Liao <liaoqiayuan@gmail.com>  Thu, 24 Nov 2022 00:00:00 -0000

ros-noetic-rm-chassis-controllers (0.1.7-1focal) focal; urgency=high

  * Merge pull request #83 <https://github.com/ye-luo-xi-tui/rm_controllers/issues/83> from rm-controls/dev
    Merge the new OmniController to master
  * Merge pull request #82 <https://github.com/ye-luo-xi-tui/rm_controllers/issues/82> from NaHCO3bc/dev
    Fix some bugs in the new OmniController.
  * Compute the params and fix some bugs.
  * Rename the function forwardKinematics to odometry.
  * Merge pull request #80 <https://github.com/ye-luo-xi-tui/rm_controllers/issues/80> from qiayuanliao/master
    New and elegant OmniController
  * Fix bug in the new OmniController
  * Add a new and elegant OmniController
  * Merge remote-tracking branch 'origin/master'
  * Contributors: NaHCO3bc, QiayuanLiao, qiayuan

 -- Qiayuan Liao <liaoqiayuan@gmail.com>  Sat, 10 Sep 2022 00:00:00 -0000

ros-noetic-rm-chassis-controllers (0.1.6-1focal) focal; urgency=high

  * Merge remote-tracking branch 'origin/master'
  * Contributors: qiayuan

 -- Qiayuan Liao <liaoqiayuan@gmail.com>  Thu, 16 Jun 2022 00:00:00 -0000

ros-noetic-rm-chassis-controllers (0.1.5-1focal) focal; urgency=high

  * Update frames in update function.
  * Add command_source_frame to follow mode.
  * Merge remote-tracking branch 'origin/master'
  * 0.1.4
  * Add damping behavior to ReactionWheelController
  * Add recover behavior to ReactionWheelController
  * Add a low-pass filter to eliminate the constant pitch angle offset to ReactionWheelController
  * Add a naive method for determining orientation of balance chassis
  * Use new reaction wheel state space model
  * Add setZero to Q and R
  * Merge remote-tracking branch 'origin/master'
  * Remove "convert model from continuous to discrete time" from ReactionWheel, the rm_common::Lqr accept continuous model.
  * Merge pull request #57 <https://github.com/ye-luo-xi-tui/rm_controllers/issues/57> from NaHCO3bc/master
    Update ReactionWheelController


=== debian/control ===
Source: ros-noetic-rm-chassis-controllers
Section: misc
Priority: optional
Maintainer: Qiayuan Liao <liaoqiayuan@gmail.com>
Build-Depends: debhelper (>= 9.0.0), ros-noetic-angles, ros-noetic-catkin, ros-noetic-controller-interface, ros-noetic-effort-controllers, ros-noetic-rm-common, ros-noetic-roscpp, ros-noetic-tf2-geometry-msgs
Homepage: 
Standards-Version: 3.9.2

Package: ros-noetic-rm-chassis-controllers
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-noetic-angles, ros-noetic-controller-interface, ros-noetic-effort-controllers, ros-noetic-rm-common, ros-noetic-robot-localization, ros-noetic-roscpp, ros-noetic-tf2-geometry-msgs
Description: RoboMaster standard robot Chassis controller

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/noetic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF -DCATKIN_ENABLE_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/noetic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/noetic" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-noetic-rm-chassis-controllers//opt/ros/noetic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_install
